#include <iostream>
#include "fdstream.hh"

void test_fdostream() {
  fdostream out(1);
  out << "31 decimal = 0x" << std::hex << std::uppercase
      << 31 << std::endl;
}

void test_fdstreams() {
  fdistream in(STDIN_FILENO);
  fdostream out(STDOUT_FILENO);

  if (isatty(0)) {
    out << "I will read 18 characters and will print them (2 "
        << "twice, due to use of 'unget()')" << std::endl;
  }

  for (int i = 1;   i <= 20;   i++) {
    char c;

    in.get(c);
    out << c << std::flush;

    if (i == 8) {
      in.unget();
      in.unget();
    }
  }
  out << std::endl;
}


int main() {
  // Tests the use of stream manipulators, and unget(), for fdistreams
  // and fdostreams

  test_fdostream();
  test_fdstreams();
  return 0;
}
